﻿Module myProgram
    Public version As String = "v0.1"
    Public name As String = "bubblecrusher"
    Public longname As String = "SciLor's Bubble Crusher"
End Module

Public Class frmBubble

    Dim BackBuffer As New Bitmap(1, 1)
    Dim BackBufferGraphics As Graphics = Graphics.FromImage(BackBuffer)
    Dim BubbleClass As BubbleCrusher '(BubbleCrusher.GameType.Normal, 1, New Size(1, 1))
    Dim ButtonSize As New Size(0, 0)
    Dim PositionFix As New Size(0, 0)
    Dim HighlightList As New List(Of Point)
    Dim ButtonPattern As New Size(11, 15)
    Dim NewGameMenus(BubbleCrusher.GameType.MaxGame - 1) As MenuItem
    Dim SelectSkinMenus() As MenuItem
    Dim CurrentSkin As Byte = 0

    Private Sub frmBubble_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Call NewGame(BubbleCrusher.GameType.SuperShift)
        Me.Text = myProgram.longname & " - " & myProgram.version
        For I As BubbleCrusher.GameType = 0 To BubbleCrusher.GameType.MaxGame - 1
            NewGameMenus(I) = New MenuItem
            NewGameMenus(I).Text = I.ToString
            AddHandler NewGameMenus(I).Click, AddressOf NewGame_Click
            mnuMain.MenuItems.Item(0).MenuItems.Add(NewGameMenus(I))
        Next
        NewGameMenus(BubbleCrusher.GameType.SuperShift).Checked = True

        ReDim SelectSkinMenus(BubbleClass.AvailableSkins.Count - 1)
        Dim J As Integer = 0
        For Each SkinName As String In BubbleClass.AvailableSkins
            SelectSkinMenus(J) = New MenuItem
            SelectSkinMenus(J).Text = SkinName
            AddHandler SelectSkinMenus(J).Click, AddressOf SelectSkin_Click
            mnuMain.MenuItems.Item(1).MenuItems.Item(0).MenuItems.Add(SelectSkinMenus(J))
            J += 1
        Next
        SelectSkinMenus(CurrentSkin).Checked = True
        Call BubbleClass.SetUpColors(CurrentSkin)
    End Sub

    Private Sub NewGame_Click(ByVal sender As MenuItem, ByVal e As EventArgs)
        Call NewGame(System.Enum.Parse(GetType(BubbleCrusher.GameType), sender.Text, True))
    End Sub

    Private Sub SelectSkin_Click(ByVal sender As MenuItem, ByVal e As EventArgs)
        CurrentSkin = Array.IndexOf(SelectSkinMenus, sender)
        For I = 0 To SelectSkinMenus.Count - 1
            SelectSkinMenus(I).Checked = False
        Next
        SelectSkinMenus(CurrentSkin).Checked = True
        Call BubbleClass.SetUpColors(CurrentSkin)
    End Sub

    Private Sub frmBubble_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseUp
        If e.X >= PositionFix.Width And e.Y >= PositionFix.Height Then
            Dim myPos As Point
            myPos.X = Int((e.X - PositionFix.Width) / ButtonSize.Width)
            myPos.Y = Int((e.Y - PositionFix.Height) / ButtonSize.Height)
            If myPos.X < BubbleClass.FieldSize.Width And myPos.Y < BubbleClass.FieldSize.Height Then
                If Not BubbleClass.Matrix(myPos.X, myPos.Y) = 0 Then
                    If BubbleClass.Crush(myPos, HighlightList) = False Then
                        HighlightList = BubbleClass.GetHighlight(myPos)
                        Call Draw()
                    Else
                        HighlightList.Clear()
                        If BubbleClass.CheckGameDone() Then
                            MsgBox("Game finished!" & vbNewLine & "Score: " & BubbleClass.GetScore)
                            NewGame(BubbleClass.LastGame)
                        End If
                    End If
                    Call Draw()
                End If
            End If
        End If
    End Sub

    Private Sub frmBubble_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        e.Graphics.DrawImage(BackBuffer, 0, 0)
    End Sub

    Private Sub frmBubble_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        If BubbleClass IsNot Nothing Then
            BackBuffer = New Bitmap(Me.ClientSize.Width, Me.ClientSize.Height)
            BackBufferGraphics = Graphics.FromImage(BackBuffer)
            'BackBufferGraphics.Clear(Color.White)
            Call SetUpDrawSize()
            Call BubbleClass.SetUpColors(ButtonSize)
            Call Draw()
        End If
    End Sub

    Private Sub SetUpDrawSize()
        Dim tempSize(1) As Integer

        tempSize(0) = Int(Me.ClientSize.Width / ButtonPattern.Width)
        tempSize(1) = Int(Me.ClientSize.Height / ButtonPattern.Height)
        If tempSize(0) > tempSize(1) Then
            ButtonSize.Width = tempSize(1)
            ButtonSize.Height = ButtonSize.Width
        Else
            ButtonSize.Width = tempSize(0)
            ButtonSize.Height = ButtonSize.Width
        End If

        PositionFix.Width = Me.ClientSize.Width / 2 - ButtonSize.Width * ButtonPattern.Width / 2
        PositionFix.Height = Me.ClientSize.Height / 2 - ButtonSize.Height * ButtonPattern.Height / 2
    End Sub

    Private Sub Draw()
        With BackBufferGraphics
            .Clear(Color.White)

            For X = 0 To BubbleClass.Matrix.GetLength(0) - 1
                For Y = 0 To BubbleClass.Matrix.GetLength(1) - 1
                    If Not BubbleClass.Matrix(X, Y) = 0 Then
                        '.FillEllipse(New SolidBrush(BubbleClass.GetButtonColor(BubbleClass.Matrix(X, Y))), PositionFix.Width + X * ButtonSize.Width, PositionFix.Height + Y * ButtonSize.Height, ButtonSize.Width, ButtonSize.Height)
                        .DrawImage(BubbleClass.GetButtonImage(BubbleClass.Matrix(X, Y)), PositionFix.Width + X * ButtonSize.Width, PositionFix.Height + Y * ButtonSize.Height)
                    End If
                Next
            Next
            If HighlightList.Count > 1 Then
                .FillEllipse(New SolidBrush(Color.LightGray), PositionFix.Width + HighlightList.Item(0).X * ButtonSize.Width, PositionFix.Height + HighlightList.Item(0).Y * ButtonSize.Height, ButtonSize.Width, ButtonSize.Height)
                For Each Highlight As Point In HighlightList
                    .DrawEllipse(New Pen(Color.White, 4), PositionFix.Width + Highlight.X * ButtonSize.Width, PositionFix.Height + Highlight.Y * ButtonSize.Height, ButtonSize.Width, ButtonSize.Height)
                    .DrawEllipse(New Pen(Color.Black, 2), PositionFix.Width + Highlight.X * ButtonSize.Width, PositionFix.Height + Highlight.Y * ButtonSize.Height, ButtonSize.Width, ButtonSize.Height)
                Next
                Dim PointSize As SizeF = .MeasureString(BubbleClass.GetCrushScore(HighlightList.Count), Me.Font)
                Me.Font = New Font(Me.Font.Name, Me.Font.Size * Math.Min((ButtonSize.Width - 4) / PointSize.Width, (ButtonSize.Height - 4) / PointSize.Height), Me.Font.Style)
                PointSize = .MeasureString(BubbleClass.GetCrushScore(HighlightList.Count), Me.Font)
                .DrawString(BubbleClass.GetCrushScore(HighlightList.Count), Me.Font, New SolidBrush(Color.Black), PositionFix.Width + HighlightList.Item(0).X * ButtonSize.Width + ButtonSize.Width / 2 - PointSize.Width / 2, PositionFix.Height + HighlightList.Item(0).Y * ButtonSize.Height + ButtonSize.Height / 2 - PointSize.Height / 2)
            End If
        End With
        Me.Refresh()
    End Sub

    Private Sub NewGame(ByVal Game As BubbleCrusher.GameType)
        Call HighlightList.Clear()
        BubbleClass = Nothing
        Call SetUpDrawSize()
        Dim ValidGame As Boolean = False

        If NewGameMenus(0) IsNot Nothing Then
            For I = 0 To NewGameMenus.Count - 1
                NewGameMenus(I).Checked = False
            Next
            NewGameMenus(Game).Checked = True
        End If

        Do While ValidGame = False
            BubbleClass = New BubbleCrusher(Game, 5, ButtonPattern, ButtonSize, CurrentSkin)
            ValidGame = Not BubbleClass.CheckGameDone
        Loop

        AddHandler BubbleClass.Redraw, AddressOf Draw
        Call Draw()
        Me.Refresh()
    End Sub

    Private Sub mniUpdateCheck_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mniUpdateCheck.Click
        Dim UpdateChecker As New SciLors_UpdateCheck.SciLorsUpdateCheck()
        MsgBox(UpdateChecker.checkVersion(myProgram.name, myProgram.longname, myProgram.version), MsgBoxStyle.OkOnly, "Update Check")
    End Sub

    Private Sub mniWebsite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mniWebsite.Click
        Dim ShellEx As New ProcessStartInfo()
        ShellEx.UseShellExecute = True
        ShellEx.FileName = "http://www.scilor.com"
        Process.Start(ShellEx)
    End Sub
End Class
